	SUBROUTINE LinMin(p,xi,n,fret)
	
	implicit none
	
	integer n
	real*8 p(n),xi(n),fret
	 
	integer nmax
	real*8 tol
	parameter(nmax=30,tol=1.d-8)
	integer ncom,j
	real*8 F1DIM,DF1DIM,pcom(nmax),xicom(nmax)
	real*8 ax,xx,bx,fa,fx,fb,xmin,DBRENT,BRENT
	
	common /f1com/ xicom,pcom,ncom
	
	external F1DIM,DF1DIM,DBRENT,BRENT
!
!------------------------------------------------------------------------
!
	ncom=n
	do j=1,n	
	  pcom(j)=p(j)   ! point itself
	  xicom(j)=xi(j) ! derivatives
	enddo
	ax = 0.d0
	xx = 1.d0
	CALL mnbrak(ax,xx,bx,fa,fx,fb,F1DIM)
!	FRET=BRENT(ax,xx,bx,F1DIM,tol,xmin)
	FRET=DBRENT(ax,xx,bx,F1DIM,DF1DIM,tol,xmin)
	Do j=1,n
	  xi(j)=xmin*xi(j)
	  p(j)=p(j)+xi(j)
	End do
	
	RETURN
	END
