SUBROUTINE DFUNC(num,pnt,df)

implicit none

integer	::	num, nmax, maxpar,maxconf
integer	::	nangskel,nangtot,ndof,ntot,nall
integer	::	natmc,natsu,nconf
parameter(nmax=20,maxpar=15,maxconf=30)
real*8	::	FUNC, pnt(nmax), f0,f1,df(nmax),dx
real*8	::	C(maxpar,maxconf)
real*8	::	VMP2(maxconf)
real*8	::	stor(nmax)
parameter(dx=1.d-6)
	
integer	::	i,j
real*8	::	locpnt(num),BCoeff,ACoeff(num),pntj,VeryBig
parameter(VeryBig=1.d+2/dx)

common	/at1/	natmc,natsu,nconf
common	/cof/	C
common	/ene/	VMP2
common	/lim/	nangskel,nangtot,ndof,ntot,nall
common	/str/	stor

external FUNC
!
!-------------------------------------------------------------
!
!	ATTENTION! Partial derivatives will NOT be minimised herein!!!
!	It is LinMin that really does the job!!!
!	This routine only serves the purpose of initialising the derivatives
!	in order to define the directions along which real minimisation takes place
!
!	Numerical calculation
!
! num=npar
! if(num<=ntot) goto 20
f0 = FUNC(pnt,num)
locpnt(1:num) = pnt(1:num)
do j=1,num
	pntj=pnt(j)
!	goto 9
!	if(pntj<dx) then
!		df(j)=VeryBig
!		goto 10
!	end if
!	if(pntj < dx) then
!		print*, 'very small point ',j,pntj,dx
!		pause
!	end if
9	locpnt(j)=pntj*(1.d0+dx)
	f1 = FUNC(locpnt,num)
	locpnt(j)=pntj
	df(j) = (f1-f0)/dx/pntj 
10	continue
enddo 

RETURN
!
!	Analytical Calculation
!
!20	if(num<=ntot) then
!
!	locpnt(1:num)=pnt(1:num)
!	locpnt(num+1:ntot)=stor(num+1:ntot)
!	do i=1,num
!		df(i)=2.d0*(dot_product(VMP2(1:nconf),C(i,1:nconf))-dot_product(C(i,1:nconf),matmul(locpnt(1:ntot),C(1:ntot,1:nconf))))
!	end do
!
!	else
!
!		print*, 'no derivatives formula available yet wrt equil angles'
!		STOP
!
!	endif
!
!RETURN
ENd SUBROUTINE DFUNC


