	SUBROUTINE mnbrak(ax,bx,cx,fa,fb,fc,FUNK1DIM)
	
	implicit none
	
	real*8 ax,bx,cx,fa,fb,fc,FUNK1DIM

	real*8 gold,glimit,tiny,q,u,r,dum,ulim,fu
	parameter(gold=1.618034d0,glimit=100.d0,tiny=1.d-20)

	external FUNK1DIM
!
!-------------------------------------------------------------------------------
!
	fa=FUNK1DIM(ax)
	fb=FUNK1DIM(bx)  
	if(fb .GT. fa) then
	  dum=ax
	  ax=bx
	  bx=dum
	  dum=fb
	  fb=fa
	  fa=dum
	end if
	cx=bx+gold*(bx-ax)
	fc=FUNK1DIM(cx)
1	if(fb .GE. fc)then
	  r = (bx-ax)*(fb-fc)	
	  q = (bx-cx)*(fb-fa)
	  u = bx-((bx-cx)*q-(bx-ax)*r)/(2.d0*dsign(max(dabs(q-r),tiny),q-r))
	  ulim = bx+glimit*(cx-bx)
	  if((bx-u)*(u-cx) .GT. 0.d0)then
	    fu=FUNK1DIM(u)
	    if(fu .LT. fc)then
	      ax=bx
	      fa=fb
	      bx=u
	      fb=fu
	      GOTO 1
	    else if(fu .GT. fb) then
	      cx=u
	      fc=fu
	      GOTO 1
	    endif
	    u=cx+gold*(cx-bx)
	    fu=FUNK1DIM(u)
	  else if((cx-u)*(u-ulim) .GT. 0.d0) then
	    fu=FUNK1DIM(u)
	    if(fu .LT. fc)then
	      bx=cx
	      cx=u
	      u=cx+gold*(cx-bx)
	      fb=fc
	      fc=fu
	      fu=FUNK1DIM(u)
	    endif
	  else if((u-ulim)*(ulim-cx) .GE. 0.d0)then
	    u=ulim
	    fu=FUNK1DIM(u)
	  else
	    u=cx+gold*(cx-bx)
	    fu=FUNK1DIM(u)
	  endif
	  ax=bx
	  bx=cx
	  cx=u
	  fa=fb
	  fb=fc
	  fc=fu
	  GOTO 1
	endif
	
	RETURN
	END
