fUNCTION TestF(pnt,num)

implicit none

integer	::	num, nmax, maxpar,maxconf
integer	::	natmc,natsu,nconf
integer	::	nbond,nang,nattyp,npair,npar
parameter(nmax=30,maxpar=30,maxconf=30)
integer	::	maxbond,maxang,maxattyp,maxpair
parameter(maxbond=5,maxang=15,maxattyp=3,maxpair=10)
integer	::	maxmc,maxsu
parameter(maxmc=11,maxsu=20)
integer	::	bondtype(maxattyp,maxattyp),angletype(maxattyp,maxattyp,maxattyp)
integer	::	pairtype(maxattyp,maxattyp)
integer	::	nangskel,nangtot,ndof,ntot,nall,iopt
real*8	::	TestF, pnt(nmax)
real*8	::	VMP2(maxconf)
real*8	::	C(maxpar,maxconf)
real*8	::	stor(nmax)
real*8	::	bl(maxbond,maxmc-1,maxconf),b(maxmc-1,maxconf,3),dl(maxbond,maxsu,maxconf),d(maxsu,maxconf,3)
real*8	::	theta(maxang,maxconf,maxang)

integer	::	i,nlim,k,j,iconf
real*8	::	pi,sigm,epslon,Upot,VFF(1:nconf),VeryBig,mrgpnt(1:maxpar)
parameter(sigm=3.d0,epslon=0.15d0,pi=3.14159265359d0,VeryBig=1.d+10)
real*4	::	ranum

common	/ff1/	nbond,nang,nattyp,npair,npar
common	/at1/	natmc,natsu,nconf
common	/cof/	C
common	/ene/	VMP2
common	/str/	stor
common	/lim/	nangskel,nangtot,ndof,ntot,nall
common	/ff2/	bondtype,angletype,pairtype
common	/bnd/	b,bl,d,dl
common	/ang/	theta
common	/opt/	iopt

external Upot
	
!------------------------------------------------------------------------

	If(any(pnt(1:num)<0.d0)) then
		CALL random_number(ranum)
		TestF=VeryBig*(1.+ranum)
!		write(*,*) 'Obj F =    VERY BIG'
		RETURN
	End if

!	update "merged" point

	mrgpnt(1:num) = pnt(1:num)

!	impose constraints

	mrgpnt(1:4)   = stor(1:4)
	mrgpnt(7)     = stor(7)
	mrgpnt(9:10)  = stor(9:10)
	mrgpnt(13)    = stor(13)
	mrgpnt(15:16) = stor(15:16)
	mrgpnt(19)    = stor(19)

	if(num<=ntot) then

		mrgpnt(num+1:ntot)=stor(num+1:ntot) ! restore constants that I want them to be unaffected.
		forall(i=1:nconf) VFF(i) = dot_product(C(1:ntot,i),mrgpnt(1:ntot)) ! In case of random search
																		   ! C*s have already been recomputed in aaamain
	
!		Do i=1,nconf
!			VFF(i) = dot_product(C(1:num,i),point(:))
!		End Do

		TestF = sum((VMP2(1:nconf)-VFF(1:nconf))**2)

	else
	
		Do i=1,nang
			k=npair+npair+nbond+i
			Do iconf=1,nconf
				C(k,iconf)=0.d0
				Do j=1,maxang  ! Some C*s have to be reevaluated because "point" has been altered by minimiser
					if(theta(i,iconf,j)>0.d0) &
					C(k,iconf)=C(k,iconf)+(theta(i,iconf,j)-mrgpnt(ntot+i))**2 
				End Do
			End Do
		End Do
		Do i=1,nbond
			k=npair+npair+nbond+nang+i
			Do iconf=1,nconf
				C(k,iconf)=0.d0
				Do j=1,natmc-1  ! Some C*s have to be reevaluated because "point" has been altered by minimiser
					if(bl(i,j,iconf)>0.d0) &
					C(k,iconf)=C(k,iconf)+(bl(i,j,iconf)-mrgpnt(ntot+nang+i))**2 
				End Do
				Do j=1,natsu  ! Some C*s have to be reevaluated because "point" has been altered by minimiser
					if(dl(i,j,iconf)>0.d0) &
					C(k,iconf)=C(k,iconf)+(dl(i,j,iconf)-mrgpnt(ntot+nang+i))**2 
				End Do
			End Do
		End Do
		C(npair+npair+nbond+1:npair+npair+nbond+nang+nbond,1:nconf)= &
		.5d0*C(npair+npair+nbond+1:npair+npair+nbond+nang+nbond,1:nconf)
		forall(i=1:nconf) VFF(i) = dot_product(C(1:ntot,i),mrgpnt(1:ntot)) ! -dot_product(C(1:ntot,1),mrgpnt(1:ntot))
		TestF = sum((VMP2(1:nconf)-VFF(1:nconf))**2)

	endif

RETURN
ENd Function TestF
