	SUBROUTINE FRPRMN(p,n,ftol,iter,fret)
	
	implicit none
	
	integer n,iter,nmax
	parameter(nmax=20)
	real*8 p(nmax),ftol,fret,drvs(nmax)
	
	integer itmax,j,its
	real*8 eps,ftol2
	parameter(itmax=5000,eps=1.d-10)
	real*8 g(nmax),h(nmax),xi(nmax),fp,FUNC,gg,dgg,gam
	
	common	/drv/	drvs
	
	external FUNC
!
!------------------------------------------------------------------------------
!
	ftol2=ftol*ftol
	fp=FUNC(p,n)
	CALL DFUNC(n,p,xi) ! ; write(*,*) '2nd call successful'
	do j=1,n
	  g(j)=-xi(j)
	  h(j)=g(j)
	  xi(j)=h(j)
	end do
	do its=1,itmax
	  iter=its
	  CALL LinMin(p,xi,n,fret) ! ; print*, 'Hey!', fp, fret
	  if(2.d0*dabs(fret-fp) .LE. ftol*(dabs(fret)+dabs(fp)+eps)) then ! RETURN
!	  if(dot_product(xi(1:n),xi(1:n)) .LE. ftol2) then
!		print*, 'HERE!!!',xi(1:n)
		drvs(1:n)=xi(1:n)
		RETURN
	  end if
	  fp=FUNC(p,n)
	  CALL dfunc(n,p,xi)
	  gg=0.d0
	  dgg=0.d0
	  do j=1,n
	    gg=gg+g(j)**2
!	    dgg = dgg+xi(j)**2			  ! this statement for Fletcher-Reeves
	    dgg = dgg+(xi(j)+g(j))*xi(j)  ! this statement for Polak-Ribiere
	  end do
	  if(gg .EQ. 0.d0) then
!		print*, 'THERE!!!',gg
		drvs(1:n)=xi(1:n)
		RETURN
	  end if
	  gam=dgg/gg
	  do j=1,n
	    g(j)=-xi(j)
	    h(j)=g(j)+gam*h(j)
	    xi(j)=h(j)
	  end do
	end do
	print*, 'FRPR max iter exceeded'
	write(2,*) 'FRPR max iter exceeded'
!	PAUSE 'FRPR max iter exceeded'
	RETURN
	END

